/**
 * @class SuspenseImage
 * @version 3.0.2
 * @author github.com/gokcan
 */
/// <reference types="node" />
import React, { ReactNode } from 'react';
import PropTypes from 'prop-types';
interface Props {
    src: string;
    fallback: ReactNode;
    errorFallback?: (err: string) => ReactNode;
    onLoad?: (image: any) => any;
    delay?: number;
    NativeImgProps?: React.ImgHTMLAttributes<HTMLImageElement>;
}
interface State {
    isLoading: boolean;
    src: string;
    error?: string;
}
export default class SuspenseImage extends React.Component<Props, State> {
    static propTypes: {
        src: PropTypes.Validator<string>;
        fallback: PropTypes.Validator<PropTypes.ReactElementLike>;
        errorFallback: PropTypes.Requireable<(...args: any[]) => any>;
        onLoad: PropTypes.Requireable<(...args: any[]) => any>;
        delay: PropTypes.Requireable<number>;
        NativeImgProps: PropTypes.Requireable<object>;
    };
    state: State;
    timeoutId?: NodeJS.Timeout;
    img?: HTMLImageElement;
    forceReject?: any;
    componentDidMount(): void;
    componentDidUpdate(prevProps: Props): void;
    componentWillUnmount(): void;
    startImageLoadingProcess: () => Promise<void>;
    private loadImage;
    safeClearTimeout(): void;
    render(): {} | null | undefined;
}
export { SuspenseImage as Image };
