import React from 'react';
import PropTypes from 'prop-types';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var IntendedError = /** @class */ (function (_super) {
    __extends(IntendedError, _super);
    function IntendedError(intention) {
        if (intention === void 0) { intention = 'forcePromiseReject'; }
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        var _this = _super.apply(this, params) || this;
        _this.createdAt = new Date();
        _this.intention = intention;
        return _this;
    }
    return IntendedError;
}(Error));

/**
 * @class SuspenseImage
 * @version 3.0.2
 * @author github.com/gokcan
 */
var SuspenseImage = /** @class */ (function (_super) {
    __extends(SuspenseImage, _super);
    function SuspenseImage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isLoading: false,
            src: '',
            error: ''
        };
        _this.startImageLoadingProcess = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, src, fallback, delay, uri, error_1;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.props, src = _a.src, fallback = _a.fallback, delay = _a.delay;
                        if (!src || !fallback) {
                            this.setState({ error: 'src and fallback props must be provided.' });
                        }
                        /*
                         * To avoid instant loading 'flash' while downloading images with high-speed internet connection
                         * (or downloading smaller images that do not need much loading-time),
                         * user may want to give delay before starting to show the loading indicator.
                         */
                        if (delay && delay > 0) {
                            this.timeoutId = setTimeout(function () {
                                _this.timeoutId = undefined;
                                if (!_this.state.src && !_this.state.error) {
                                    _this.setState({ isLoading: true });
                                }
                            }, delay);
                        }
                        else {
                            this.setState({ isLoading: true });
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.loadImage(src)];
                    case 2:
                        uri = _b.sent();
                        this.setState({ isLoading: false, src: uri });
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _b.sent();
                        // If this is an intended(forced) rejection, don't make it visible to user.
                        if (!(error_1 instanceof IntendedError)) {
                            this.setState({ error: error_1, isLoading: false });
                        }
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        _this.loadImage = function (uri) { return __awaiter(_this, void 0, void 0, function () {
            var onLoad;
            var _this = this;
            return __generator(this, function (_a) {
                onLoad = this.props.onLoad;
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var img = new Image();
                        if (_this.img) {
                            _this.img.onload = null;
                            _this.img.onerror = null;
                            // Previous promise call must be cancelled for decode().
                            _this.forceReject && _this.forceReject(new IntendedError());
                        }
                        _this.img = img;
                        img.src = uri;
                        _this.forceReject = reject;
                        img.decode !== undefined
                            ? img
                                .decode()
                                .then(function () {
                                resolve(img.src);
                                if (onLoad)
                                    onLoad(img);
                            })
                                .catch(function () {
                                reject(new Error('An Error occurred while trying to decode an image'));
                            })
                            : (img.onload = function () {
                                resolve(img.src);
                                if (onLoad)
                                    onLoad(img);
                            });
                        img.onerror = function () {
                            reject(new Error('An Error occurred while trying to download an image'));
                        };
                    })];
            });
        }); };
        return _this;
    }
    SuspenseImage.prototype.componentDidMount = function () {
        this.startImageLoadingProcess();
    };
    SuspenseImage.prototype.componentDidUpdate = function (prevProps) {
        var src = this.props.src;
        if (src && src !== prevProps.src) {
            this.safeClearTimeout();
            this.startImageLoadingProcess();
        }
    };
    SuspenseImage.prototype.componentWillUnmount = function () {
        // The component might be cancelled(unmounted) before the 'delay' timeout finishes.
        this.safeClearTimeout();
        this.forceReject = undefined;
        this.img = undefined;
    };
    SuspenseImage.prototype.safeClearTimeout = function () {
        if (this.timeoutId) {
            clearTimeout(this.timeoutId);
            this.timeoutId = undefined;
        }
    };
    SuspenseImage.prototype.render = function () {
        var _a = this.state, src = _a.src, error = _a.error, isLoading = _a.isLoading;
        var _b = this.props, fallback = _b.fallback, errorFallback = _b.errorFallback, NativeImgProps = _b.NativeImgProps;
        if (isLoading) {
            return fallback;
        }
        else if (error) {
            if (errorFallback) {
                return errorFallback(error);
            }
            else {
                return (React.createElement("span", { role: 'img', "aria-label": 'Image failed to load' }, "\u274C"));
            }
        }
        return React.createElement("img", __assign({ src: src }, NativeImgProps));
    };
    SuspenseImage.propTypes = {
        src: PropTypes.string.isRequired,
        fallback: PropTypes.element.isRequired,
        errorFallback: PropTypes.func,
        onLoad: PropTypes.func,
        delay: PropTypes.number,
        NativeImgProps: PropTypes.object
    };
    return SuspenseImage;
}(React.Component));

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".styles_root__3hJ8K {\n\tdisplay: inline-block;\n}\n\n.styles_shimmer__2k7PV {\n\tbackground: #f6f7f8;\n\tbackground-image: linear-gradient(to right, #eeeeee 8%, #dddddd 18%, #eeeeee 33%);\n\tbackground-repeat: no-repeat;\n\tbackground-position: 0 0;\n\tbackground-size: 1000 100;\n\tanimation-duration: 1.6s;\n\tanimation-fill-mode: forwards;\n\tanimation-iteration-count: infinite;\n\tanimation-name: styles_shimmering__kjn-s;\n\tanimation-timing-function: ease-in-out;\n\tdisplay: inline-block;\n}\n\n@keyframes styles_shimmering__kjn-s {\n\t0% {\n\t\tbackground-position: top right;\n\t}\n\n\t100% {\n\t\tbackground-position: top left;\n\t}\n}\n";
var cls = {"root":"styles_root__3hJ8K","shimmer":"styles_shimmer__2k7PV","shimmering":"styles_shimmering__kjn-s"};
styleInject(css_248z);

var calcShimmerStyle = function (width, height, duration) {
    if (duration === void 0) { duration = 1600; }
    var backgroundSize = width * 10 + "px " + height + "px";
    var shimmerStyles = {
        backgroundSize: backgroundSize,
        animationDuration: (duration / 1000).toFixed(1) + "s"
    };
    return shimmerStyles;
};
var Shimmer = function (_a) {
    var duration = _a.duration, _b = _a.height, height = _b === void 0 ? 400 : _b, _c = _a.width, width = _c === void 0 ? 400 : _c;
    var shimmerStyle = calcShimmerStyle(width, height, duration);
    var style = __assign(__assign({}, shimmerStyle), { height: height, width: width });
    return (React.createElement("div", { className: cls.root },
        React.createElement("span", { className: cls.shimmer, style: style })));
};

export default SuspenseImage;
export { Shimmer };
//# sourceMappingURL=index.js.map
